# -*- coding: utf-8 -*-

# Este script Assina o xml gerado das notas canceladas que não possuem assinatura


from nfe.nfc_e import nfce as nfc_e
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)


print 'Iforme os seguintes dados'
erp_host = 'localhost'
erp_usuario = 'openerp'
erp_nome = 'construmais_t'
erp_senha = ''
sup_host = 'localhost'
sup_usuario = 'openerp'
sup_nome = 'construmais_t'
sup_senha = ''
# erp_host = raw_input('Ip do ERP: ')
# erp_usuario = raw_input('Usuario do postgres ERP: ')
# erp_nome = raw_input('Nome do Banco ERP: ')
# erp_senha = raw_input('Senha do Banco ERP: ')


cont = 0
msg = []
try:
    print '>>>>>> Copiando certificado......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    conn_sup = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host,
                            password=sup_senha, connect_timeout=20)
    cr_sup = conn_sup.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cr.execute("""
                    SELECT certificado_conteudo,
                           chave_conteudo,
                           data_validade,
                           proprietario_certificado
                    FROM fiscal_parametro
                    WHERE company_id = 1
                   """)
        brw_dados = get_browse(dictfetchall(cr)[0])
        cr_sup.execute("""
                    UPDATE supervisor_cfg_configuracao
                    SET supcfc_certificado_conteudo = '%s',
                        supcfc_chave_conteudo = '%s',
                        supcfc_data_validade = '%s',
                        supcfc_proprietario_certificado = '%s';
                    COMMIT;
                   """ % (brw_dados.certificado_conteudo,
                          brw_dados.chave_conteudo,
                          '%s' % brw_dados.data_validade,
                          brw_dados.proprietario_certificado))

        print '\n\nFinalizado!'
    except Exception as e:
        print 'Erro ao copiar certificado: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
